﻿# The script of the game goes in this file.

# Declare characters used by this game. The color argument colorizes the
# name of the character.

define fp = Character("Paul's father")
define p = Character("Paul")
define t = Character("Terry")
define m = Character("Maria")
define c = Character("Claudia")
define s = Character("@Snappy003")

# The game starts here.

label start:
    camera:
        perspective True

    # Show a background. This uses a placeholder by default, but you can
    # add a file (named either "bg room.png" or "bg room.jpg") to the
    # images directory to show it.

    scene bg kitchen
    with fade
    play music "audio/1.mp3"
   
    # This shows a character sprite. A placeholder is used, but you can
    # replace it by adding a file named "eileen happy.png" to the images
    # directory.
    
    "Three friends, Paul, Terry and Maria, live quite an ordinary life for young people their age. " 

    "School, hobbies, local things. Nothing is wrong, sure, but sometimes things get boring."
     
    
    
    show t 1:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 1:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 1:
        subpixel True pos (0.17, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0     


    

 
    "One day, at the kitchen table of Paul's house, they are dreaming for something interesting to do, something new and exciting… but what?"
 
    "Paul's dad comes with an idea: he knows of an interesting Youth Center downtown where they organize some pretty cool free time activities."
 
    
    show 14:
        subpixel True pos (-0.02, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0

  
    fp "Hey guys - he says - there is a cool series of workshops coming up. Inspiring speakers. Do you want to join?"

    menu:

        "Yes":

            jump ch2pr1

        "No":

            jump nope


label ch2pr1:

    $ menu_flag = True
 
    scene bg kitchen
    play music "audio/1.mp3"
       
    show p 2:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0

    "Paul thought about it, then decided to accept. His dad had interesting ideas, sometimes."
 
    "Plus, what could go wrong?" 
    
    show p 3:
        subpixel True pos (0.08, 0.15)
        alpha 0.0
        linear 1.0 alpha 1.0    
    p"In the worst case - he told his friends - we would have a boring experience. Just like many others."
    
    
    show t 1:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0        
    show m 1:
        subpixel True pos (0.29, 0.13)
        alpha 0.0
        linear 1.0 alpha 1.0

    "While he had to struggle a bit to convince Terry, Maria was much more easy going." 
    show m 2:
        subpixel True pos (0.29, 0.13) 
    m "Come on! - said Maria - It will be an interesting experience, and we can even end up learning something!"

    
    jump theYouthEvent
 
 
label nope:

    scene bg kitchen
    play music "audio/1.mp3"

    $ menu_flag = False

    show p 2:
        subpixel True pos (0.29, 0.15)  
        alpha 0.0
        linear 1.0 alpha 1.0

    "Paul was perplexed. His dad has great ideas, sometimes, but how could he convince his friends to follow him?"
 
    "He decided it was too complicated."


    p "Uh, no thanks, dad, I think I'll pass - he said - Thanks anyway."

    jump school
 
label school:

    scene bg school
    play music "audio/class.mp3"

    "The next day, at school, Terry looked really hyped up."
    

    show t 5:
        subpixel True pos (0.17, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 1:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 1:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0     

    t "Hey, have a look at this guy on Instagram! - he said while pointing excitedly at his phone." 
    
    show instagram post small:
        xpos -1 
        alpha 0.0
        linear 1.0 alpha 1.0
        
    
    "@Snappy003 was a local influencer, quite famous at the local level. People loved his social media and his streams. "
    "This time he was promoting a street art festival, coming up this weekend."
    "With some nice pictures and just a few catchy words, he said it was going to be cool, and a lot of interesting people were going to be there."
    t "Shall we go have a look? - Terry asked his friends."

    "Paul wasn't so sure. He was not big into arts, and street art in particular was not very appealing to him."
    show p 2:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
        
    "Maria, on the other hand, was curious." 

    show m 3:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0

    m "Why not? she said. I love art, and this may be a chance to try out something new!"
    "Her enthusiasm could be contagious."
    
    "So, what are you going to do? Will you check out the street art festival next weekend?"

  

    menu:

        "Yes, let's do it!":

            jump ch2pr2

        "Naaa..":

            jump end1

label ch2pr2:

    $ menu_flag = True
 
    scene bg school
    play music "audio/class.mp3"

    "Terry has had some crazy ideas in the past, but this one seemed fine."
    "After all, what could go wrong?" 
    "In the worst case they were going to spend some time trying - and failing - some street art." 
    "A good alternative to yet another boring weekend, all considered."
 
       
    "So, Paul decided to follow his friends' suggestion, and they all made plans to join the festival."

    jump theYouthEvent
 
label theYouthEvent:
    # ... the game continues here.

    scene bg skate
    play music "audio/hip.mp3"

    "The place was interesting. Buzzing with people, most of them young, everybody was active doing all sorts of things,"
    "some of which the friends had never seen before. Painting, skateboard, jam music sessions going on everywhere," 
    "and people who seemed intent in some very animated discussions. What were they talking about?"

    show t 4:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 4:
        subpixel True pos (0.15, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 4:
        subpixel True pos (0.43, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0


    
    "The three friends had just entered the space, when one person stepped towards them."

    
    show c 2:
        subpixel True pos (0.57, 0.17) 
        alpha 0.0
        linear 1.0 alpha 1.0

    c "'Hello, I am Claudia', she said, with a friendly voice and a warm smile." 
    c "'You must be new around here'. It was not so much of a question, more like a statement."
    
    m "'Well, yes', Maria was the quickest to answer. 'We came because of the announcement'"
    c "'Just at the perfect time!' replied Claudia."

    show t 1:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 1:
        subpixel True pos (0.15, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 1:
        subpixel True pos (0.43, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show c 1:
        subpixel True pos (0.57, 0.17) 
        alpha 0.0
        linear 1.0 alpha 1.0

    c "'A workshop on youth participation is starting right now, I will be hosting it. Want to join us?'"

    show t 5:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0

    t "'A workshop on what?' asked Terry. The question was on everybody's mind." 
    "They were familiar with the word 'participation', but they had never heard it connected to youth. What did it even mean?"
    c "'Youth participation', said Claudia with an understanding smile."
    c "'Would you like to make a difference in the place where you live? The community, the people around you?'"
    c "'Come and find out how. That's youth participation, it means to have an active life and care about the things around you'"
    "That sounded… interesting. Sure the three friends cared for the place and the people around them. "
    
    m "'So… should we go?' asked Maria."
    show t 3:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    t "'There are so many cool things happening here right now!' objected Terry" 
    t "This workshop would take the whole afternoon and it probably means sitting in a room discussing politics and things."
    t "What about other young people? The music? The fun?” It was a good point." 
    "Claudia was waiting for an answer" 
    c "'Come on guys', she said. 'We are just about to start' "
    "Do you want to join the workshop?"

  

    menu:

        "Mmm, alright, let's see what it's like":
            show p 3:
                subpixel True pos (0.43, 0.15) 
                alpha 0.0
                linear 1.0 alpha 1.0
            p "'Yes, we like the idea' Paul replied. His friends gave him a quick perplexed look, but he was faster and didn't leave space for their doubts to grow. 
            Sometimes a bit of initiative was needed."
            show c 1:
                subpixel True pos (0.57, 0.17) 
                alpha 0.0
                linear 1.0 alpha 1.0
            c "'Very well, then follow me!' exclaimed Claudia with an excited giggle. She seemed really happy to have found new friends. 
            The girl started to trot down a hallway, and the three friends followed her." 


            jump ch3

        "Maybe another time, thanks anyway":

            show p 2:
                subpixel True pos (0.43, 0.15) 
                alpha 0.0
                linear 1.0 alpha 1.0
            p "'I think we will pass', said Paul. They were not completely convinced, and he didn't want to be responsible in case his friends got bored. 
            It's so hard to take the initiative, sometimes!"

            jump graffiti

    
label graffiti:
    # ... workshop streetart.

    scene bg graffiti
    play music "audio/graf.mp3"

   
    

    "They moved on to another area. In a more central space, a group of young people were all busy doing different activities. 
    Some were jamming with their musical instruments, some seemed engaged in discussions, 
    but the biggest attraction seemed to be a big wall divided in sections."
    show t 4:
        subpixel True pos (0.12, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 4:
        subpixel True pos (0.25, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 4:
        subpixel True pos (0.43, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    
    t "'What's going on here?' asked Terry, faking a perfect self-confident attitude. Or maybe he was just like that. "
    show s 1:
        subpixel True pos (0.57, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    
    s "It's a graffiti competition', replied a voice behind them. 'Going to start soon. We are going to make a difference today'.
    The three friends turned around, and they couldn't hide their excitement when they realized they were talking to @Snappy003 in person!"
    
    show t 1:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 2:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 1:
        subpixel True pos (0.17, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0   
    show s 3:
        subpixel True pos (-0.02, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0


    m "Yeah… what?” rambled Maria, a little star struck. "
    s "'Various local artists will paint different sections of the wall', replied the influencer, 'and the panels will be placed in town as street art'."
    s "He seemed to pause for a second. 'Actually… We still have an empty panel. It would be a pity to just let it like that. Do you want to try?'"
    show p 2:
        subpixel True pos (0.17, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0 
    
    p "'What?' replied Paul, unsure about what to do. "
    show s 2:
        subpixel True pos (-0.02, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    s "'Yes, let's see how you manage. We are all ready anyway. So, are you in?' asked Snappy003. 'Have you ever tried?'"
    "What to do? Paul didn't really have any experience with art, and Terry liked the street vibe but was terrible at drawing. 
    On the other hand, Maria loved everything connected with culture and at school, she had a passion for art class." 
    "Graffiti was a different thing, however. Their work would look terrible next to so many professionals, 
    and the pictures would soon be on everybody's social media."

    "Do you want to join the graffiti exhibition?"

  

    menu:

        "Yeah, sounds cool!":

            jump ch4

        "No, bro, thank you!":

            jump end2
   
label ch3:
    # ... workshop participation.

    scene bg circle
    play music "audio/circle.mp3"

    show t 1:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 1:
        subpixel True pos (0.15, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 1:
        subpixel True pos (0.43, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show c 3:
        subpixel True pos (0.57, 0.17) 
        alpha 0.0
        linear 1.0 alpha 1.0
   

    "The group reached a room, which was already busy by the sound of it. Inside there was a group of young people, apparently busy discussing something. 
    When the small group joined them, the activities was just about to start"
    show c 1:
        subpixel True pos (0.57, 0.17) 
        alpha 0.0
        linear 1.0 alpha 1.0
    
    c "'Ehì, hello everybody' said Claudia. 'Nice to see so many of you here. My name is Claudia, and I will be your facilitator today'."
    "So she was going to lead the activity! The friends had no idea! "
    "The workshop ended up being very interesting. It wasn't a boring lecture at all. Claudia started with some fun, 
    fast ice-breaking activities which helped people to know each other, "
    "and then had interactive sessions with stimulating titles like 'what are the needs of your local community?' and 'how to successfully run a fundraising campaign'."
    "At the end, almost three hours had passed and the group had barely noticed. "
    show t 5:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    t "'Wow, I had no idea' said Terry to his friends when they were leaving the place. 
    'This was so much fun, and interesting at the same time. So is this what you call… active participation?'"
    c "'Yes', replied Claudia with a knowing smile. 'And this is just the beginning. We meet every week at the youth club and we work on these topic. Wanna join us?'"

    "What to do?" 


  

    menu:

        "Accept and make it a regular activity":

            jump end3

        "refuse, too much hard work...":

            jump end1

label ch4:
    # ... graffiti workshop.

    scene bg graffiti
    play music "audio/graf.mp3"

   
    
    

    "So the three friends got to work. They picked some spray cans, and started to follow their inspiration.
    The panel started to explode with color and shapes. All around them, the space was really inspiring! 
    A courtyard recovered from an industrial building of some sort, which was now bustling with activities and creative energy. "

    "This really helped the group to be immersed in the process and to get more creative. 
    They spent the best part of an hour decorating their panel, and chose a nature-inspired motive, "

    scene bg waves
    play music "audio/graf.mp3"
    show t 1:
        subpixel True pos (0.29, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 1:
        subpixel True pos (0.17, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 1:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0   
    "blue waves of clear, blue water running through it. "

    "At the end, the result was definitely not as interesting as what some of the other artists had done, but it was definitely good enough for a first try. "
    show s 3:
        subpixel True pos (-0.02, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0

    "Snappy003 passed by to check on them. He gave half a look to their creation."
    s "'Mmmmh, first time?' he muttered. 'Hard to believe, you kids are talented!'. And like that, he was gone. "

    "The friends didn't win any prize, nor saw the mysterious influencer again that day. But they enjoyed the experience, and that was enough. Something had changed." 
    show m 2:
        subpixel True pos (0.17, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    m "'Hey Paul', Maria asked. 'I would like to keep doing this. Do you think I have what it takes? Would you come with me to the art shop? "
    show m 3:
        subpixel True pos (0.17, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    m "'I always dreamed of being an artist'."

    "Paul paused a second to think. Did he want to encourage Maria? Or was it a bad idea? 
    A failure was very likely, and he didn't want his friend to get hurt." 

 

    menu:

        "Count on me Maria, decided Paul in the end":

            jump end4

        "Mmmm, I'm not sure about this":    
            show p 2:
                subpixel True pos (0.53, 0.15) 
                alpha 0.0
                linear 1.0 alpha 1.0
            p "'Well… I don't know Maria' said Paul, 'Are you sure about this? I mean, yeah, it's cool, but I don't think artists make a great living after all… 
            I suggest you take some more time to reflect about it'"
            "The three friends walked away and went back to their usual things. "
            scene bg wall
            play music "audio/wall.mp3"
            show m 4:
                subpixel True pos (0.17, 0.13) 
                alpha 0.0
                linear 1.0 alpha 1.0
            "Maria thought about her life as an artist and ended up believing herself that it would not be a wise choice, giving up her dreams…"

            return  
 
label end1:
    # This ends the game.
    $ menu_flag = True
 
    scene bg wall
    play music "audio/wall.mp3"
    
    "It was so difficult to find something interesting to do!" 
    "One idea passed, and then another, it just seemed too hard to get everybody interested. "
    show t 3:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 1:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 2:
        subpixel True pos (0.17, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0   
    "And so one day passed after another. The three friends were still living the same old life." 
    "Waiting for something special to happen, a bit bored, lacking inspiration." 
    "They felt there was more to life than their everyday routine, but what? They still didn't know."
    "Do you want to find out? Go back to page 1 and make a different choice! "

    menu:

        "Yes":

            jump start

        "No":

            return
    
label end2:
    # This ends the game.
    $ menu_flag = True
 
    scene bg graffiti
    play music "audio/graf.mp3"
    
    show t 1:
        subpixel True pos (0.53, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 2:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 2:
        subpixel True pos (0.17, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0   
    show s 4:
        subpixel True pos (-0.02, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    p "'Well… thank you for the offer' stuttered Paul, 'But I think this wouldn't be a good idea. A lot of hard work but we would end up disappointed. 
    It's probably not worth it'. "
    "The three friends shared a perplexed look and shrugged. The idea was interesting, but they were too afraid to be embarrassed. It was not worth the risk. "
    s "'Well, your choice', replied Snappy003, immediately losing interest in them. 'See you around, I guess'. "
    "The three friends stayed in the background, but soon got bored looking at everybody being so busy with so many different things. 
    They just were not brave enough to try something new. In the end, the afternoon was nice, but nothing special. Just another day and not one to remember."

    "Would you like to try a different experience? Go back to the street art festival and try a different choice!"

    menu:

        "Yes":

            jump theYouthEvent

        "No":

            return
    
label end3:
    # This ends the game.
    $ menu_flag = True
 
    scene bg ngo
    play music "audio/circle.mp3"
    
    "The regular meetings were even more interesting than they expected. In just a few weeks, Paul, Terry and Maria 
    started to regularly use words and concepts from non-formal education and took an active role in their learning, and as citizens. "
    "Soon enough, they wanted more. They wanted to organize their own activities, to get more people involved, 
    to make new like-minded friends. They wanted to make a difference at the local level. How to do it?"
    show t 5:
        subpixel True pos (0.15, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show m 3:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    show p 1:
        subpixel True pos (0.43, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    
    "After a quick brainstorming they decided to start a youth organization. 
    The paperwork was not too intimidating, and as they found out, it was cheap enough. "
    "They decided to call it “Active Life”. Terry volunteered to be the chairperson, 
    and put his energies to good use. Within one year, the association had ten members."
    "Paul was so impressed that such a small decision had made a decisive impact on his friends life. 
    And that's what it means to be active citizens in a nutshell! "

    return

label end4:
    # This ends the game.
    $ menu_flag = True
 
    scene bg atelier
    play music "audio/hip.mp3"
    
    show m 4:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
        
    "Maria was electrified by the experience. With a little encouragement and help from her friends, 
    she purchased colors and materials, and started practicing regularly. "
    "Within a few weeks, her progress was amazing. She took a big step and created her own social media platforms, 
    publishing her work to promote herself as an artist. "
    show m 3:
        subpixel True pos (0.29, 0.13) 
        alpha 0.0
        linear 1.0 alpha 1.0
    "She started to think of herself as an artist, and decided to enrol in the local university to follow art courses. "
    show p 1:
        subpixel True pos (0.43, 0.15) 
        alpha 0.0
        linear 1.0 alpha 1.0
    "Paul was so impressed that such a small decision had made a decisive impact on his friends life. 
    And that's what it means to be active citizens in a nutshell! "

    return